<!DOCTYPE html>
<html lang="en">

<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.3/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>

  <div class="container">
    <div class="text-center my-4">
      <h2>Danh sách người dùng</h2>
    </div>

    <table class="table table-bordered table-striped table-hover" id="table-users">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Age</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>
        
      </tbody>
    </table>
  </div>
  ​
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gJsonUser = `{
    "description": "Data user",
    "users": [
      {
        "userId": 1,
        "firstname": "Test1",
        "lastname": "User1",
        "age": 18
      },
      {
        "userId": 2,
        "firstname": "Test2",
        "lastname": "User2",
        "age": 19
      },
      {
        "userId": 3,
        "firstname": "Test3",
        "lastname": "User3",
        "age": 18
      },
      {
        "userId": 4,
        "firstname": "Test4",
        "lastname": "User4",
        "age": 20
      },
      {
        "userId": 5,
        "firstname": "Test5",
        "lastname": "User5",
        "age": 21
      },
      {
        "userId": 6,
        "firstname": "Test6",
        "lastname": "User6",
        "age": 20
      }
    ]
  }`;
    var gUserObj = JSON.parse(gJsonUser);
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function() {
      onPageLoading();
      // gán sự kiện cho các nút detail
      $(".user-detail").click(function() {
        onBtnDetailButtonClick(this);
      });
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm xử lý việc tải trang
    function onPageLoading() {
      // load dữ liệu json vào table
      loadDataToUserTable(gUserObj.users);
    }

    // hàm xử lý sự kiện cho nút detail button
    function onBtnDetailButtonClick(paramButton) {
      console.log("Nút Detail click");
      var vUserId = $(paramButton).data("userid");
      var vFirstname = $(paramButton).data("firstname");
      var vLastname = $(paramButton).data("lastname");
      var vAge = $(paramButton).data("tuoi");
      console.log(vUserId);
      console.log(vFirstname);
      console.log(vLastname);
      console.log(vAge);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // $(selector).action()

    // hàm load dữ liệu user vào table
    // input: paramUsers là 1 mảng users
    function loadDataToUserTable(paramUsers) {
      var vUserTable = $("#table-users");
      for(var bI = 0; bI < paramUsers.length; bI ++) {
        // tạo ra 1 dòng mới và gắn vào table
        var bNewRow = $("<tr>").appendTo(vUserTable);
        // tạo ra các ô tương ứng với các cột trên table và cũng gắn vào dòng mới ở trên
        // điền dữ liệu cho từng ô
        $("<td>", {html: paramUsers[bI].userId }).appendTo(bNewRow);
        $("<td>", {html: paramUsers[bI].firstname }).appendTo(bNewRow);
        $("<td>", {html: paramUsers[bI].lastname }).appendTo(bNewRow);
        $("<td>", {html: paramUsers[bI].age }).appendTo(bNewRow);
        // tạo ô action cell
        var bActionCell = $("<td>").appendTo(bNewRow);
        $("<button>", {
          html: "Chi tiết",
          class: "btn btn-primary user-detail"
        }).data("userid", paramUsers[bI].userId)
        .data("firstname", paramUsers[bI].firstname)
        .data("lastname", paramUsers[bI].lastname)
        .data("tuoi", paramUsers[bI].age)
        .appendTo(bActionCell);
      }
    }

  </script> 
</body>

</html>
​